#!/usr/bin/python
# -*- coding: iso-8859-2 -*-

# 12.02.2007
# Mateusz Styrczula

""" represents an abstract angle, conversion methods, comparision, etc... """

import sys
import os
import math

from misc import *



def rad_to_deg (rad):
    """ converts value in radians to value in degrees """
    return (rad * 180.0) / math.pi


def deg_to_rad (deg):
    """ converts value in degrees to value in radians """
    return (deg * math.pi) / 180.0




class Angle:
    """ angle class """

    # enum...
    deg, rad = range (0, 2)

    def __init__ (self, a = 0.0, kind = 0):
        """ default constructor """
        # angle value (stored in degrees)
        if kind == Angle.deg:
            self.set_deg (a)
        elif kind == Angle.rad:
            self.set_rad (a)
        else:
            raise Exception ("Invalid 'kind' parameter");


    def set_rad (self, a):
        """ set angle in radians """
        self.__angle_ = rad_to_deg (a)


    def get_rad (self):
        """ return Angle value in radians """
        return deg_to_rad (self.__angle_)


    def set_deg (self, a):
        """ set angle in degrees """
        self.__angle_ = a


    def get_deg (self):
        """ return Angle value in degrees """
        return self.__angle_

   
    def fit_to_360 (self):
        """ fits angle in 0 to 360 degrees range """
        self.__angle_ -= math.floor (self.__angle_ / 360.0) * twopi

