-- Animation dumping script (MAX 7)
-- dumps transform animation (position, rotation, scale)
-- Mateusz Styrczula
-- 25.02.2007


-- open file for animation dump
out_name = ("c:/scene.anim")
out_file = createfile out_name
-- find every object-roots in the scene (roots = rootNode.children)
roots = for o in objects where o.parent == undefined collect o
-- do some "dump" for every object in the scene
fn animation_dump objs out_file = (
	if objs != undefined then (
		for obj in objs do (
			-- check if node is geometry-object
			if (not isKindOf obj GeometryClass) or
			   (classof obj == TargetObject) then
				continue
			-- store mesh name
			format "%\n" (obj.name) to:out_file
			-- store mesh unique id
			format "%\n" (getUserProp obj "__uid_") to:out_file
			for frame = animationRange.start to animationRange.end do (
				at time frame (
					in coordsys parent (
						-- store mesh position
						format "%,%,%:" (obj.position.x) (obj.position.y) (obj.position.z) to:out_file
						-- store mesh rotation (convert quaternion representation to axis-angle)
						rot_axis = copy obj.rotation.axis
						format "%,%,%,%:" (rot_axis.x) (rot_axis.y) (rot_axis.z) (obj.rotation.angle) to:out_file
						-- store mesh scale
						format "%,%,%#" (obj.scale.x) (obj.scale.y) (obj.scale.z) to:out_file
					)
				)
			)
			format "\n" to:out_file
			animation_dump obj.children out_file
		) -- end for obj in objs
	) -- end if objs != undefined
) -- end fn animation_dump objs
-- invoke dump process
animation_dump roots out_file
-- close geometry dump file
close out_file
